#include <windows.h>

#include "buzz.h"
#include "outmachine.h"
#include "machinelist.h"

OUTPUTS_INFO oi=
{
	"Machine",
	MAX_OUTS,
	MAX_BUFFER_LENGTH,
	POUT_MODE_INTERLEAVED|POUT_MODE_USE_IN_GAIN
};

HINSTANCE hAppInstance=0;
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason==DLL_PROCESS_ATTACH)
	{									
		hAppInstance=hinstDLL;
	}		
	else if (fdwReason==DLL_PROCESS_DETACH)
	{		
		
	}
	
	return 1;
}

CMachineAttribute paraADummy =
{
	"Dummy",
	0,                      
	1,                   
	0                  	
};

CMachineParameter const paraGDummy =
{
	pt_word,                
	"Dummy",          		
	"Dummy",           		
	0,                      
	1,                    
	0xffff,                 		
	MPF_STATE,              		
	0                    
};

CMachineParameter const paraTDummy =
{
	pt_byte,                
	"Dummy",          		
	"Dummy",           		
	0,                      
	1,                    
	0xff,                 		
	MPF_STATE,              		
	0                    
};

CMachineParameter const *pParameters[] = 
{	
	&paraGDummy,
	&paraTDummy		
};

CMachineAttribute const *pAttributes[] = 
{
	&paraADummy
};


CMachineInfo const MacInfo = 
{
	MT_GENERATOR,
	MI_VERSION,
	MIF_USES_LIB_INTERFACE,
	0,            
	MAX_OUTS,
	1,        
	1,        
	pParameters, 
	1,           
	pAttributes, 
	"Test", 
	"Test",             
	"Test",
	NULL,
	NULL
};

mi::mi() : outs(&oi)
{		
	ex.pmi=this;	
	
	GlobalVals=&gval;
	TrackVals=tval;
	AttrVals=(int*)&aval;	
	
	numTracks=0;
}

mi::~mi() 
{	
	M_Lock();
	M_Deoffer(MACH_MULTI_OUT_3,this);		
	M_Unlock();	
	
	M_FreeMachines();		
}

char const *miex::DescribeParam(int const param)
{	
	
	return NULL;
}

void mi::Stop(void)
{		
}

void mi::SetNumTracks(int const n) 
{	
	if (n>numTracks)
	{
		int i=n-numTracks;
		while (i--)
		{
			outs.AddOutput("Send",POUT_STEREO);
		}
	}
	else if (n<numTracks)
	{
		int i=numTracks-n;
		while (i--)
		{
			outs.RemoveOutput();
		}
	}		

	numTracks=n;
}

void mi::MidiNote(int const channel, int const value, int const velocity)
{	
}

void mi::AttributesChanged(void)
{	

}

void mi::Init(CMachineDataInput * const pi)
{		
	cm=pCB->GetThisMachine();
	pCB->SetnumOutputChannels(cm,2);
	pCB->SetMachineInterfaceEx((CMachineInterfaceEx *)&ex);
	CMachineInfo *cminfo=(CMachineInfo *)pCB->GetMachineInfo(cm);

	OUTPUT *o=outs.AddOutput("Master",POUT_STEREO);
			
	om.outs=&outs;
	
	M_LoadMachines();		

	M_Lock();		
	M_Offer(MACH_MULTI_OUT_3,this,(FARPROC)MachineCallback,cm,cminfo,0);
	M_Unlock();

	if (pi!=NULL)
	{	 
	}
		
}

void mi::Save(CMachineDataOutput *const po)
{
}

void mi::Tick() 
{	
	outs.DoTick();
}

bool mi::Work(float *psamples, int numsamples, int const mode)
{	
	return false;
}

bool mi::WorkMonoToStereo(float *pin, float *pout, int numsamples, int const mode) 
{		
	if (mode&WM_WRITE)
	{
		if (outs.DoWork(pout,numsamples)) return true;
	}

	return false;
}

void mi::Command(int const i)
{

}

char const *mi::DescribeValue(int const param, int const value)
{
	return "unused";
}

#pragma optimize ("", on)


DLL_EXPORTS
